//forward secure sig demo
#include "fssig.h"

int main(void)
{
    pairing_t pairing;
    fs_sys_param_t param;
    fs_public_key_t pk;
    fs_private_key_t sk;
    fs_dec_key_t dk;
    unsigned char *sig;
    int i;
    
    printf("reading pairing from stdin...\n");

    pairing_init_inp_str(pairing, stdin);
    printf("generating fs system parameters...\n");
    fs_gen_sys_param(param, pairing);
    printf("generating key pair...\n");
    fs_gen(pk, sk, dk, param, 160, 128);
    
    sig = (unsigned char *) malloc(param->sig_length);
    
    for (i = 0; i < 128; i++) {
      printf("checking key...");
      if (fs_check_key(sk, pk)) {
        printf("check key succeeds\n");
      }
      else {
        printf("check key fails\n");
      }
      printf("signing...\n");
      fs_sign(sig, (unsigned char *) "helloworld", 160, pk, sk, dk);
      
      printf("verifying...");
      if (fs_verify(sig, (unsigned char *) "helloworld", 160, i, pk)) {
	printf("signature verifies\n");
      } else {
	printf("signature does not verify\n");
      }
      printf("updating to period %d...\n", i+1);
      fs_update(sk, pk);
    }
    free(sig);
    return 0;
}
